#ifndef SHELLSCROLLBAR_H
#define SHELLSCROLLBAR_H

#include "glm/vec2.hpp"
#include "scene/meshnode.h"

class SparrowShell;

class ShellScrollBar// : public MeshNode
{
    SparrowShell* m_shell;
    glm::ivec2 m_position;
    glm::ivec2 m_dimension;
    MeshNode *m_mesh;
public:
    ShellScrollBar();
    ShellScrollBar(SparrowShell* shell);
    void update();
};
#endif // SHELLSCROLLBAR_H
